require 'dxruby'
require_relative('cha')
require_relative('data')
require_relative('title')



class Stage

  def initialize()
    $me = Me.new(0,0)
    # Enemy 出現タイミング
    @count_now = 0
    @count_max = 240
    @score_image = Image.loadToArray('pic/hyoji.png',40,1)

    @started = false
    @start_count = 70
    @start_image = Image.load('pic/start2.png')

    @go_image  = Image.load('pic/go.png')
    @go0_image = Image.load('pic/go0.png')
    @go1_image = Image.load('pic/go1.png')
    @go2_image = Image.load('pic/go2.png')

    @go_count = 0

    @gage_image = Image.new(600,8,[0,0,0,0])
    @water_gage = 1200
    $oto.playbg
  end # end of initialize

  def scene

    # うんちんぐひょうじ
    if !@started then
      Window.draw(400-@start_image.width/2,
                  150-@start_image.height/2, @start_image)
      @start_count -= 1
      if @start_count == 0 then
        @started = true
      end
    end

    # 水のゲージ
    if @water_gage < 1200
      @water_gage += 1
    end

    @gage_image.fill([0,0,0,0])
    if @water_gage < 600 then
      @gage_image.boxFill(0, 0, @water_gage/2, 8,[32, 0,0,0])
    elsif @water_gage < 1200 then
      @gage_image.boxFill(0, 0, @water_gage/2, 8,[64, 0,0,0])
    elsif @water_gage == 1200 then
      @gage_image.boxFill(0, 0, @water_gage/2, 8,[96, 0,0,0])
    end
    @gage_image.box(0, 0, 600, 8, [0,0,0])
    Window.draw(100,284,@gage_image)

    # 水を流す---------------------------------------------------------------
    liv_un = 0
    if $unchi_list.length == 0 then
      $water = false
    end
    1.upto($unchi_list.length) do |i|
      if !$unchi_list[i-1].kill_or_not then
        liv_un += 1
      end
    end

    1.upto($enemy_list.length) do |i|
      if !$enemy_list[i-1].kill_or_not and ($enemy_list[i-1].onHit>0) then
        liv_un += 1
      end
    end

    if liv_un == 0 then
      $water = false
      $hit_benki = 0
    end
    if Input.mousePush?(M_RBUTTON) and @started and @water_gage >= 600 then
      @water_gage -= 600
      $oto.play(2)
      $water = true
    end
    #------------------------------------------------------------------------

    # 便器出現処理-----------------------------------------------------------
    if !$water then
      @count_now+=1
    end
    if (@count_now >= @count_max) and !$game_over then
      @count_now = 0
      if @count_max > 30 then
        @count_max -= 2
      end

      gen = false
      1.upto($enemy_list.length) do |i|
        if $enemy_list[i-1].kill_or_not then
          $enemy_list[i-1] = Enemy.new()
          gen = true
          break
        end
      end

      if !gen then
        $enemy_list[$enemy_list.length] = Enemy.new()
      end
    end
    #--------------------------------------------------------------------------

    for i in $enemy_list do
      i.draw()
    end

    $me.draw()


    if !$game_over then
      for i in $enemy_list do
        i.move()
      end

      $me.move()
    end

    if $game_over then
      Window.draw(400-@go_image.width/2, 64, @go_image)
      case ($go_riyu)
      when 0 then
        Window.draw(400-@go0_image.width/2, 180, @go0_image)
      when 1 then
        Window.draw(400-@go1_image.width/2, 180, @go1_image)
      when 2 then
        Window.draw(400-@go2_image.width/2, 180, @go2_image)
      end

      # タイトルへ
      if @go_count >= 60 and Input.mousePush?(M_LBUTTON) then
        $now_scene = 0
        $oto.play(0)
        $title = Title.new()
      end

      if @go_count == 5 then
        $oto.stopbg
      end

      if @go_count == 20 then
        $oto.play(1)
      end

      @go_count += 1

    end


    # スコア表示
    1.upto($score.to_s.length) do |i|
      Window.draw(8+(i-1)*16,
                  8,
                  @score_image[
                  x1=$score.to_s[i-1].to_i])
    end
    Window.draw(8+$score.to_s.length*16, 8, @score_image[10])

  end # end of scene
end